<?php
Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "provider_practice_listing".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "ProviderPracticeListing".
 *
 * Columns in table "provider_practice_listing" available as properties of the model,
 * followed by relations of table "provider_practice_listing" available as properties of the model.
 *
 * @property integer $id
 * @property integer $listing_type_id
 * @property integer $practice_id
 * @property integer $provider_id
 * @property string $date_added
 * @property string $date_updated
 * @property string $date_sync_checked
 * @property string $source
 * @property string $sync_status
 * @property string $claim_status
 * @property string $lrd_left
 * @property string $lrd_right
 * @property string $shortened_url
 * @property string $url
 * @property integer $verified
 *
 * @property ListingType $listingType
 * @property Practice $practice
 * @property Provider $provider
 */
abstract class BaseProviderPracticeListing extends BaseModel
{
    public $organization_name='';
    public $provider_name='';
    public $practice_name='';

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'provider_practice_listing';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'ProviderPracticeListing|ProviderPracticeListings', $n);
    }

    public static function representingColumn()
    {
        return 'url';
    }

    public function rules()
    {
        return array(
            array(
                'listing_type_id',
                'required'
            ),
            array(
                'listing_type_id, practice_id, provider_id, verified',
                'numerical',
                'integerOnly' => true
            ),
            array(
                'source, sync_status, claim_status',
                'length',
                'max' => 20
            ),
            array(
                'lrd_left, lrd_right',
                'length',
                'max' => 18
            ),
            array(
                'shortened_url',
                'length',
                'max' => 255
            ),
            array(
                'url',
                'length',
                'max' => 65535
            ),
            array(
                'date_added, date_updated, date_sync_checked, url',
                'safe'
            ),
            array(
                'practice_id, provider_id, date_added, date_updated, date_sync_checked, source, sync_status, claim_status, lrd_left, lrd_right, shortened_url, url, verified,organization_id',
                'default',
                'setOnEmpty' => true,
                'value' => null
            ),
            array(
                'id, listing_type_id, practice_id, provider_id, date_added, date_updated, date_sync_checked, source, sync_status, claim_status, lrd_left, lrd_right, shortened_url, url, organization_name,verified',
                'safe',
                'on' => 'search'
            )
        );
    }

    public function relations()
    {
        return array(
            'listingType' => array(
                self::BELONGS_TO,
                'ListingType',
                'listing_type_id'
            ),
            'practice' => array(
                self::BELONGS_TO,
                'Practice',
                'practice_id'
            ),
            'provider' => array(
                self::BELONGS_TO,
                'Provider',
                'provider_id'
            )
        );
    }

    public function pivotModels()
    {
        return array();
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'listing_type_id' => null,
            'practice_id' => null,
            'provider_id' => null,
            'date_added' => Yii::t('app', 'Date Added'),
            'date_updated' => Yii::t('app', 'Date Updated'),
            'date_sync_checked' => Yii::t('app', 'Date Sync Checked'),
            'source' => Yii::t('app', 'Source'),
            'sync_status' => Yii::t('app', 'Sync Status'),
            'claim_status' => Yii::t('app', 'Claim Status'),
            'lrd_left' => Yii::t('app', 'Lrd Left'),
            'lrd_right' => Yii::t('app', 'Lrd Right'),
            'shortened_url' => Yii::t('app', 'Shortened Url'),
            'url' => Yii::t('app', 'Url'),
            'verified' => Yii::t('app', 'Verified'),
            'listingType' => null,
            'practice' => null,
            'provider' => null
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria();

        $criteria->compare('id', $this->id);
        $criteria->compare('listing_type_id', $this->listing_type_id);
        $criteria->compare('practice_id', $this->practice_id);
        $criteria->compare('provider_id', $this->provider_id);
        $criteria->compare('date_added', $this->date_added, true);
        $criteria->compare('date_updated', $this->date_updated, true);
        $criteria->compare('date_sync_checked', $this->date_sync_checked, true);
        $criteria->compare('source', $this->source, true);
        $criteria->compare('sync_status', $this->sync_status, true);
        $criteria->compare('claim_status', $this->claim_status, true);
        $criteria->compare('lrd_left', $this->lrd_left, true);
        $criteria->compare('lrd_right', $this->lrd_right, true);
        $criteria->compare('shortened_url', $this->shortened_url, true);
        $criteria->compare('verified', $this->verified, true);
        $criteria->compare('url', $this->url, true);

        return new CActiveDataProvider(
            $this,
            array(
                'criteria' => $criteria,
                'pagination' => array(
                    'pageSize' => 100
                )
            )
        );
    }
}
